<?php

	//IPAY88 KREDIVO RESPONSE URL
	
	// Require libraries needed for gateway module functions.
	include("../../../includes/functions.php");
	include("../../../includes/gatewayfunctions.php");
	include("../../../includes/invoicefunctions.php");
	
	if (file_exists('../../../dbconnect.php')) 
	{
		include '../../../dbconnect.php';
	} 
	
	else if (file_exists('../../../init.php')) 
	{
		include '../../../init.php';
	} 
	
	else 
	{
		die('[ERROR] In modules/gateways/ipay88/ipay88_callback.php: include error: Cannot find dbconnect.php or init.php');
	}
	
	
	global $CONFIG;
	
	$GATEWAY = getGatewayVariables(ipay88_kredivo);

	if (!$GATEWAY["type"]) die("Module Not Activated"); # Checks gateway module is active before accepting callback
	
	if (isset($_REQUEST['RefNo'])) 
	{
		# Get Returned Variables
		$fee = 0; // additional fees to be charged by using this payment , default set to 0 (no additonal fee)
		
		//Get reference number response
		$RefNo_response = trim(stripslashes($_REQUEST['RefNo']));
		$invoiceId 		= $RefNo_response;
		
		//Checks invoice ID is a valid invoice number or ends processing
		$invoiceId   = checkCbInvoiceID($invoiceId, $GATEWAY['name']);
														
		$viewinvoice = $CONFIG['SystemURL']."/viewinvoice.php?id=".$invoiceId;
		$clientarea  = $CONFIG['SystemURL']."/clientarea.php?action=invoices";
							
		//Trans ID + error response
		$error_response     = $_REQUEST['ErrDesc'];
		$transid_response   = $_REQUEST['TransId'];	
		
		//Checks transaction number isn't already in the database and ends processing if it does
		//checkCbTransID($transid_response); 
						
		//Get signature response
		$signature_response	= $_REQUEST['Signature'];
				
		//Generate signature
		$MechantKey_response 	= $GATEWAY['merchant_key_kredivo'];
		$MerchantCode_response 	= $_REQUEST['MerchantCode'];
		$PaymentId_response		= $_REQUEST['PaymentId'];
		$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
		$Currency_response 		= $_REQUEST['Currency'];
		$Status_response 		= $_REQUEST['Status'];
				
		$merchant_signature	= "";
		
		$merchant_encrypt	= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
			
		for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
		{	
			$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
		}
			
		$merchant_signature_check = base64_encode($merchant_signature);
		
		$table  = "tblorders";
		$fields	= "invoiceid, id";
		$where 	= array("invoiceid" => $invoiceId);
		$result	= select_query($table, $fields, $where);
		$data 	= mysql_fetch_array($result);
		$id 	= $data['id'];
				
		//Payment success and signature match
		if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
		{		
			header("Location:".$clientarea."");
			exit();			
		}
		
		//Payment pending
		elseif ($_REQUEST['Status']=="6" && $merchant_signature_check==$signature_response) 
		{	
			header("Location:".$clientarea."");
			exit();
		}
			
		//Payment failed
		else
		{
			$error_response = $_REQUEST['ErrDesc'];
			
	 		logTransaction($GATEWAY["name"], $_POST, "Unsuccessful");
			
			$table	= "tblhosting";
			$update	= array("domainstatus"	=> "Cancelled");
			$where	= array("orderid" 		=> $id);
			
			update_query($table, $update, $where);
			
			$table	= "tbldomains";
			$update	= array("status"	=> "Cancelled");
			$where	= array("orderid" 	=> $id);
			
			update_query($table, $update, $where);		
			
			$table	= "tblorders";
			$update	= array("status"		=> "Cancelled");
			$where	= array("invoiceid" 	=> $invoiceId);
			
			update_query($table, $update, $where);	
			
			$table	= "tblorders";
			$update	= array("notes"		=> "iPay88 Kredivo Payment Failed. Error description: ".$error_response.".");
			$where	= array("invoiceid" => $invoiceId);
			
			update_query($table, $update, $where);	
																					
    		header("Location:".$viewinvoice."&paymentfailed=true");
			exit();		
		}	
	}
	
	else
	{	
		header("Location:".$CONFIG['SystemURL']."");
		exit();
	}

?>


